function checkIfTextfieldEmpty(textfieldComp,errorMessage)
{
  //alert("In checkIfTextfieldEmpty .......");
  var name = trimAll(textfieldComp.value);
  if(name.length == 0)
  {
    alert(errorMessage);
    return true;
  }
  
  return false;
  
}

function checkIfSelectEmpty(selectComp,errorMessage)
{
  //alert('In checkIfSelectEmpty .......');
  var len = selectComp.options.length;
  if(len == 0)
  {
    alert(errorMessage);
    return true;
  }
  
  return false;
}

function underConstruction()
{
    alert(I18N.getMsg("js.validate.underConstruction.alert"));
}

function isValidIPAddress(ipaddr)
{
   var re = /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/;
   if (re.test(ipaddr)) 
   {
      var parts = ipaddr.split(".");
      if (parseInt(parseFloat(parts[0])) == 0) 
      { 
        return false; 
      }
      for (var i=0; i<parts.length; i++) 
      {
         if (parseInt(parseFloat(parts[i])) > 255) 
         { 
           return false;
         }
      }
      return true;
   } 
   else 
   {
      return false;
   }
}




 
    function checkEmailAddress(str)
    {
            var at="@"
            var dot="."
            var lat=str.indexOf(at)
            var lstr=str.length
            var ldot=str.indexOf(dot)
            var errorMessage = I18N.getMsg("js.validate.checkEmailAddress.variable.1") + " " + str + " " + I18N.getMsg("js.validate.checkEmailAddress.variable.2");
            if (str.indexOf(at)==-1)
            {
                alert(errorMessage)
                return false
            }
            
            if (str.indexOf(at)==-1 || str.indexOf(at)==0 || str.indexOf(at)==lstr)
            {
                alert(errorMessage)
                return false
            }
            
            if (str.indexOf(dot)==-1 || str.indexOf(dot)==0 || str.indexOf(dot)==lstr)
            {
                alert(errorMessage)
                return false
            }
            
            if (str.indexOf(at,(lat+1))!=-1)
            {
                alert(errorMessage)
                return false
            }
            
            if (str.substring(lat-1,lat)==dot || str.substring(lat+1,lat+2)==dot)
            {
                alert(errorMessage)
                return false
            }
            
            if (str.indexOf(dot,(lat+2))==-1)
            {
                alert(errorMessage)
                return false
            }
            
            if (str.indexOf(" ")!=-1)
            {
                alert(errorMessage)
                return false
            }
            
            return true
        }

function hostNameValidation(hostName)
{
    if(hostName.length == 0)
    {
        alert(I18N.getMsg("js.validate.hostNameValidation.alert.1"));
        return false;
    }

    var parts = hostName.split(".");

    if(parts[0].length == 0)
    {
        alert(I18N.getMsg("js.validate.hostNameValidation.alert.2"))
        return false;
    }

    if(isNumber(parts[0]))
    {
        if(!isValidIPAddress(hostName))
        {
            alert(I18N.getMsg("js.validate.hostNameValidation.alert.3"));
            return false;
        }
    }
    
    return true;

}

function isValidSyslogFrwd(ipAddress)
{
	if(isNotEmpty(ipAddress))
	{
		var ips = ipAddress.split(",");
		for (var i=0; i < ips.length; i++) 
		{
			if(!isValidIPAddress(ips[i].trim()))
			{
				alert(I18N.getMsg("js.validate.isValidSyslogFrwd.alert")+": >>> " + ips[i]);
				return false;
			}
		}
	}
	return true;
}


function isNumber(str)
{
    str = trimAll(str);
    if(str.length==0) return false;
    numdecs = 0;
    for (i = 0; i < str.length; i++)
    {
        mychar = str.charAt(i);
        if ((mychar >= "0" && mychar <= "9") || mychar == "." )
        {
            if (mychar == ".")
                numdecs++;
        }
        else return false;
    }
    if (numdecs > 1){return false;}
    return true;
}

function loadDiscoverStatusPage(addressid)
{
       var url = 'NCMAdminAutoDiscoveryMessageStatus.cc?ADDRESSID=' + addressid;
       window.open(url,'autodiscovery','width=400,height=200')
         
}

function isAlphaNumericDotDash(str, formElement){
   if(!isNotEmpty(str))
   {
     return false;
   }

    //var objRegExp = /^[a-zA-Z0-9_\-\. ]+$/;
    //if(objRegExp.test(str)){
      //  return true;
    //}
        return true;
    }

function isContainOnlyNumericValues(textObj,fieldName)
{
    if (parseInt(textObj.value) != textObj.value)
    {
        alert(I18N.getMsg("js.validate.isContainOnlyNumericValues.alert")+" \""+fieldName+"\"");
        textObj.focus();
        textObj.select();
        return false;
    }
    return true;
}


/* For validation SNMPTrapSettings screen */

function validateTrapPort(value,formElement)
{
  value = trimAll(value);
  if(isNotEmpty(value))
  {
    if(!isContainOnlyNumericValues(formElement,"Destination Port"))
    {
        return false;
    }
  }

  return true;
}


function validate_edit_form(form)	 
 {	 
     if(!isNotEmpty(form.ANNOTATION.value))	 
     {	 
       alert(I18N.getMsg("js.validate.validate_edit_form.alert.1"));	 
       form.ANNOTATION.focus();	 
       return false;	 
     }	 
     else if(!isNotEmpty(form.CHANGEDBY.value))	 
     {	 
       alert(I18N.getMsg("js.validate.validate_edit_form.alert.2"));	 
       form.CHANGEDBY.focus();	 
       return false;	 
     }	 
    	 
     else	 
     {	 
         return true;	 
     }	 
 }

function validate_auth_reason(form)	 
 {	 
       if(!isNotEmpty(form.MESSAGE_BOX.value))	 
         {	 
             alert(I18N.getMsg("js.validate.validate_auth_reason.alert"));	 
             form.MESSAGE_BOX.focus();	 
             return false;	 
         }	 
       else	 
       {	 
             return true;	 
       }	 
 	 
 }

//added by prabhat for multiple email validation, other pre written functions are not working...
function validate(email) {
   var reg = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
   return reg.test(email);
}

function trimEmail(str){
	var	str = str.replace(/^\s\s*/,''),
		ws = /\s/,
		i = str.length;
	while (ws.test(str.charAt(--i)));
	return str.slice(0, i + 1);
}


// code ends here by prabhat....
function validateServerSetting(form)
{
  if(!validateForm(form))
  {
    return false;
  }
  if(!(form.TFTP_BOX_VISIBLE.value=="localhost"))
  {
    if(!isValidIPAddress(form.TFTP_BOX_VISIBLE.value))
    {
          alert(I18N.getMsg("js.validate.hostNameValidation.alert.3"));//No I18N
          return false;
    }
  }
  if(!(form.SCP_BOX_VISIBLE.value=="localhost"))
  {
  if(!isValidIPAddress(form.SCP_BOX_VISIBLE.value))
  {
          alert(I18N.getMsg("js.validate.hostNameValidation.alert.3"));//No I18N
          return false;
  }
  }
  if(!(form.SYSLOG_BOX_VISIBLE.value=="localhost"))
  {
  if(!isValidIPAddress(form.SYSLOG_BOX_VISIBLE.value))
  {
          alert(I18N.getMsg("js.validate.hostNameValidation.alert.3"));//No I18N
          return false;
  }
  }
}
function validateExcludeCriteriaForAdd(form)
{
  var status = true;
  if(!validateForm(form))
  {
    return false;
  }

var toAddress = form.EXCLUDE_EMAIL.value;

if(!isNotEmpty(toAddress))
{
	return true;
}
      if(isNotEmpty(toAddress))
	{
		 toAddrArray = toAddress.split(",");
		var len = toAddrArray.length;
		for(i=0;i<len;i++)
		{
			if(!validate(trimEmail(toAddrArray[i])))
			{
                                alert(I18N.getMsg("js.validate.checkEmailAddress.variable.1") + " " + toAddrArray[i] + " " + I18N.getMsg("js.validate.checkEmailAddress.variable.2"));//No I18N
				status= false;
                                break;
			}
		}
	}
        if(!status)
        {
                return false;
        }
	return true;
}
function validateForSpaceInCustomColumn(form)
    {
        var colName1 = form.COLUMN_NAME1.value;
        var colName2 = form.COLUMN_NAME2.value;
        var colValue1 = form.COLUMN_VALUE1.value;
        var colValue2 = form.COLUMN_VALUE2.value
        if(!validateForm(form))
        {
            return false;
        }
         if(isNotEmpty(colName2) && isNotEmpty(colValue1) )
         {

             if(!isNotEmpty(colName1))
             {
                 alert(I18N.getMsg("js.devicegroup.customcolumn.fillColumn1"));
                 form.COLUMN_NAME1.focus();
                 return false;
             }
         }
         if( isNotEmpty(colName1) && isNotEmpty(colValue2) )
         {
             if(!isNotEmpty(colName2))
             {
                alert(I18N.getMsg("js.devicegroup.customcolumn.fillColumn2"));
                form.COLUMN_NAME2.focus();
                return false;
             }
         }
         if(isNotEmpty(colValue1) && isNotEmpty(colValue2) )
         {
             if(!isNotEmpty(colName2) && !isNotEmpty(colName1))
             {
                alert(I18N.getMsg("js.devicegroup.customcolumn.fillColumnboth"));
                form.COLUMN_NAME1.focus();
                return false;
             }
         }
         if(isNotEmpty(colValue1))
         {
             if(!isNotEmpty(colName1))
             {
                alert(I18N.getMsg("js.devicegroup.customcolumn.fillColumn1"));
                form.COLUMN_NAME1.focus();
                return false;
             }
         }
         if(isNotEmpty(colValue2))
         {
             if(!isNotEmpty(colName2))
             {
                alert(I18N.getMsg("js.devicegroup.customcolumn.fillColumn2"));
                form.COLUMN_NAME1.focus();
                return false;
             }
         }
    }
